Index: libabac/abac_pl_yy.c
===================================================================
--- libabac/abac_pl_yy.c	(revision a9494ad1c5e523f94b0d172045537662de58fd54)
+++ libabac/abac_pl_yy.c	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -4,16 +4,19 @@
 #include <string.h>
 #include <stdlib.h>
-
-#include "uthash.h"
+#include <assert.h>
+
 #include "abac_util.h"
-
 #include "abac_pl_yy.h"
 
 static int debug=0;
 
-extern abac_list_t *generate_pl_clauses(abac_role_t *, abac_role_t *);
+extern abac_list_t *generate_pl_role_clauses(abac_role_t *, abac_role_t *);
+extern abac_list_t *generate_pl_oset_clauses(abac_oset_t *, abac_oset_t *);
 extern void panic(char*);
 extern char *generate_pl_type_clause(char *, int);
 void _add_yy_id_certs(char *, int);
+static void _free_yy_oset(abac_yy_oset_t *ptr);
+static void _free_yy_term_data(abac_yy_term_data_t *ptr);
+abac_role_t *validate_head_role(abac_yy_expression_t *expr);
 
 abac_list_t *abac_yap_clauses=NULL;
@@ -21,31 +24,53 @@
 abac_stack_t *abac_yap_id_clauses=NULL;
 
+int abac_yap_is_oset=0;
 abac_role_t *abac_yap_head_role=NULL;
 abac_role_t *abac_yap_tail_role=NULL;
 
-/* XXX do we want to check whether the id cert is preexisting or not */
-/* this is to track id certs within a rule clause */
+abac_oset_t *abac_yap_head_oset=NULL;
+abac_oset_t *abac_yap_tail_oset=NULL;
+
+/* to track id certs within a rule clause */
 typedef struct _abac_yy_id_cert_t {
     char *principalname;
     int type; /* keyidtype */
     char *clause;
-
-    UT_hash_handle hh;
 } abac_yy_id_cert_t;
-
 abac_list_t *abac_yy_id_certs = NULL;
+
+/* structure to hold the range information
+   within a static constraints on few types of
+   oset types 
+   [a..b], [a..], [..b], [a],[a,b],[many a] 
+   e_yy_RANGE_MIN=1;
+   e_yy_RANGE_MAX=2;
+   e_yy_RANGE_TARGET=3;
+*/
+typedef struct _abac_yy_range_t {
+    int type;
+    char *val;
+} abac_yy_range_t;
+
+/* to track role/oset constraint clauses used within a rule clause,
+   collect them up in one place */
+typedef struct _abac_yy_constraint_t {
+    char *clause;
+} abac_yy_constraint_t;
+abac_list_t *abac_yy_constraints = NULL;
 
 /* local principal structure  [keyid:USC] */
 struct _abac_yy_principal_t {
     int type;
-    char *sha;
-    char *cn;
+    char *sha; // sha is null when this is of object type
+    char *cn; 
 };
 
-/* like  [principal:?Z]:..., must match a principal name */
-struct _abac_yy_param_principal_t {
+/* [principal:?Z]:..., must match a principal name */
+struct _abac_yy_term_principal_t {
     int type; /* this needs to be implicitly determined */
     char *name;
     char *condition;
+    void *cptr; // ptr to a saved abac_role_t
+    abac_yy_expression_t *cond_head_expr;
 };
 
@@ -57,21 +82,28 @@
     [int:10]
 */
-struct _abac_yy_param_data_t {
+struct _abac_yy_term_data_t {
     int is_variable;
     int type;
     char *name;
     char *condition;
+    void *cptr; // ptr to a saved abac_oset_t
+    abac_list_t *cond_range;
+    abac_yy_expression_t *cond_head_expr; // parking stub
 };
 
-/* local dterm structure, will distinguish it in the future */
-struct _abac_yy_dterm_t {
+/* local term structure, will distinguish it in the future */
+/* e_yy_DTERM_DATA,      all other types
+   e_yy_DTERM_NAMED,     keyid:bob
+   e_yy_DTERM_PRINCIPAL, principal:?P
+   e_yy_DTERM_ANONYMOUS  ? */
+struct _abac_yy_term_t {
     union {
          abac_yy_principal_t *n_ptr;
-         abac_yy_param_principal_t *p_ptr;
-         abac_yy_param_data_t *d_ptr;
+         abac_yy_term_principal_t *p_ptr;
+         abac_yy_term_data_t *d_ptr;
     } term;
     int type;
-    struct _abac_yy_dterm_t *next;
-    int bcnt; /* this is to track number of dterms in this linked up list */
+    struct _abac_yy_term_t *next;
+    int bcnt; /* this is to track number of terms in this linked up list */
 };
 
@@ -80,19 +112,150 @@
    int type;
    char *name;
-   abac_yy_dterm_t *dterms;
+   abac_yy_term_t *terms;
    struct _abac_yy_role_t *next;
    int bcnt; /* this is to track number of roles in this linked up list */
 };
 
-struct _abac_yy_role_expression_t {
-   int rtype;
-   abac_yy_principal_t *principal;
+/* local oset structure */
+struct _abac_yy_oset_t {
+   int type;
+   char *name;
+   abac_yy_term_t *terms;
+   struct _abac_yy_oset_t *next;
+   int bcnt; /* this is to track number of oset in this linked up list */
+};
+
+/* A, A.r, A.r.r */
+/* type: e_yy_EXPR_NAMED,e_yy_EXPR_ROLE,e_yy_EXPR_LINKED */
+/* A/obj, A.o, A.r.o */
+/* type: e_yy_EXPR_NAMED, e_yy_EXPR_OBJECT, e_yy_EXPR_OSET,e_yy_EXPR_LINKED */
+struct _abac_yy_expression_t {
+   int type;
+   union {
+       abac_yy_principal_t *principal;
+       abac_yy_term_data_t *object;
+   };
    abac_yy_role_t *linked_role;
-   abac_yy_role_t *role;
-   struct _abac_yy_role_expression_t *next;
+   union {
+       abac_yy_role_t *role;
+       abac_yy_oset_t *oset;
+   };
+   struct _abac_yy_expression_t *next;
    int bcnt;
 };
-
-static void _free_yy_dterm(abac_yy_dterm_t *ptr);
+static void _free_yy_term(abac_yy_term_t *ptr);
+
+/************************************************************************/
+static void _free_yy_range(abac_list_t *ptr) 
+{
+    if (ptr != NULL) {
+        abac_yy_range_t *cur;
+        abac_list_foreach(ptr, cur,
+            if(cur && cur->val) free(cur->val);
+            free(cur);
+        );
+        abac_list_free(ptr);
+    }
+}
+
+char *string_yy_cond_range(abac_list_t *ptr)
+{
+    assert(ptr);
+    char *tmp=NULL;
+    char *min=NULL;
+    char *max=NULL;
+    char *val=NULL;
+    int type;
+
+    abac_yy_range_t *cur;
+    abac_list_foreach(ptr, cur,
+        type=cur->type;
+        val=cur->val; 
+        switch (type) {
+            case e_yy_RANGE_MIN:
+                min=strdup(cur->val);
+                break;
+            case e_yy_RANGE_MAX:
+                max=strdup(cur->val);
+                break;
+            case e_yy_RANGE_TARGET:
+                if(val)
+                    asprintf(&val,"%s,%s",val,cur->val);
+                else val=strdup(cur->val);
+                break;
+        }
+    );
+    if(max && min) {
+         asprintf(&tmp,"[%s..%s]",min,max);
+         free(max);
+         free(min);
+         return tmp;
+    }
+    if(max) {
+         asprintf(&tmp,"[..%s]",max);
+         free(max);
+         return tmp;
+    }
+    if(min) {
+         asprintf(&tmp,"[%s..]",min);
+         free(min);
+         return tmp;
+    }
+    if(val) {
+         asprintf(&tmp,"[%s]",val);
+         free(val);
+         return tmp;
+    }
+    return NULL;
+}
+
+abac_list_t *addto_yy_val_range(abac_list_t *ptr, char * val)
+{
+    abac_yy_range_t *range= 
+         (abac_yy_range_t *) abac_xmalloc(sizeof(abac_yy_range_t));
+    range->type=e_yy_RANGE_TARGET;
+    range->val=strdup(val);
+    abac_list_add(ptr, range);
+    return ptr;
+}
+
+static abac_list_t *_addto_yy_range(abac_list_t *ptr, int type, char * val)
+{
+    abac_yy_range_t *range= 
+         (abac_yy_range_t *) abac_xmalloc(sizeof(abac_yy_range_t));
+    range->type=type;
+    range->val=strdup(val);
+    abac_list_add(ptr, range);
+    return ptr;
+}
+
+abac_list_t *make_yy_val_range(char *val)
+{
+    abac_list_t *ptr=abac_list_new();
+    addto_yy_val_range(ptr,val);
+    return ptr;
+}
+
+abac_list_t *make_yy_minmax_range(char *min, char *max)
+{
+    abac_list_t *ptr=abac_list_new();
+    _addto_yy_range(ptr, e_yy_RANGE_MIN, min);
+    _addto_yy_range(ptr, e_yy_RANGE_MAX, max);
+    return ptr;
+}
+
+abac_list_t *make_yy_min_range(char *min)
+{
+    abac_list_t *ptr=abac_list_new();
+    _addto_yy_range(ptr, e_yy_RANGE_MIN, min);
+    return ptr;
+}
+
+abac_list_t *make_yy_max_range(char *max)
+{
+    abac_list_t *ptr=abac_list_new();
+    _addto_yy_range(ptr, e_yy_RANGE_MAX, max);
+    return ptr;
+}
 
 /************************************************************************/
@@ -119,5 +282,5 @@
     if(debug) {
          printf("printing out abac_yap_clauses:\n");
-         abac_print_clauses(abac_yap_clauses);
+         abac_print_clauses(abac_yap_clauses,NULL);
     }
 }
@@ -139,4 +302,9 @@
 }
 
+int abac_get_yap_is_oset()
+{
+   return abac_yap_is_oset;
+}
+
 abac_role_t *abac_get_yap_head_role()
 {
@@ -149,4 +317,15 @@
 }
 
+abac_oset_t *abac_get_yap_head_oset()
+{
+    return abac_yap_head_oset;
+}
+
+abac_oset_t *abac_get_yap_tail_oset()
+{
+    return abac_yap_tail_oset;
+}
+
+/*******************************************************************/
 void abac_init_yy_id_certs()
 {
@@ -164,4 +343,5 @@
     );
     abac_list_free(abac_yy_id_certs);
+    abac_yy_id_certs = NULL;
 }
 
@@ -214,4 +394,53 @@
 
 /****************************************************************************/
+void abac_init_yy_constraints()
+{
+    abac_yy_constraints = abac_list_new();
+}
+
+void abac_free_yy_constraints()
+{
+    abac_yy_constraint_t *cur;
+    abac_list_foreach(abac_yy_constraints, cur,
+        if(cur && cur->clause) 
+            free(cur->clause);
+        free(cur);
+    );
+    abac_list_free(abac_yy_constraints);
+    abac_yy_constraints=NULL;
+}
+
+int abac_cnt_yy_constraints()
+{
+    return abac_list_size(abac_yy_constraints);
+}
+
+char *abac_string_yy_constraints()
+{
+    int first=1;
+    char *tmp=NULL;
+    abac_yy_constraint_t *cur;
+    abac_list_foreach(abac_yy_constraints, cur,
+        if(cur && cur->clause) 
+            if(first) {
+                tmp=abac_xstrdup(cur->clause);
+                first=0;
+                } else {
+                    int cnt=asprintf(&tmp,"%s,%s", tmp, cur->clause);
+            }
+    );
+    return tmp;
+}
+
+abac_yy_constraint_t *abac_add_yy_constraints(char *constraint)
+{
+    abac_yy_constraint_t *ptr=
+        (abac_yy_constraint_t *) abac_xmalloc(sizeof(abac_yy_constraint_t));
+    ptr->clause=strdup(constraint);
+    abac_list_add(abac_yy_constraints, ptr);
+    return ptr;
+}
+
+/****************************************************************************/
 abac_yy_principal_t *make_yy_principal(char *sha, char *cn, int type)
 {
@@ -232,9 +461,21 @@
 }
 
-abac_yy_role_t *make_yy_role(char *name, abac_yy_dterm_t *dterms)
+int get_yy_principal_type(abac_yy_principal_t *ptr)
+{
+    return ptr->type;
+}
+
+char *get_yy_principal_principalname(abac_yy_principal_t *ptr)
+{
+    if(ptr->sha == NULL)
+        return ptr->cn;
+    return ptr->sha;
+}
+
+abac_yy_role_t *make_yy_role(char *name, abac_yy_term_t *terms)
 {
     abac_yy_role_t *ptr=(abac_yy_role_t*)abac_xmalloc(sizeof(abac_yy_role_t));
     ptr->name=abac_xstrdup(name);
-    ptr->dterms=dterms;
+    ptr->terms=terms;
     ptr->next=NULL;
     ptr->bcnt=1;
@@ -245,6 +486,6 @@
 {
     free(ptr->name);
-    if(ptr->dterms)
-        _free_yy_dterm(ptr->dterms);
+    if(ptr->terms)
+        _free_yy_term(ptr->terms);
     if(ptr->next)
         _free_yy_role(ptr->next);
@@ -252,12 +493,20 @@
 }
 
-abac_yy_role_expression_t *make_yy_role_expression(int rtype,
-abac_yy_principal_t *principal, abac_yy_role_t *role, abac_yy_role_t *linked_role)
-{
-    abac_yy_role_expression_t *ptr=
-         (abac_yy_role_expression_t*)abac_xmalloc(sizeof(abac_yy_role_expression_t));
-    ptr->rtype = rtype;
-    ptr->principal = principal;
-    ptr->role = role;
+/* type: e_yy_EXPR_NAMED, e_yy_EXPR_OBJECT, e_yy_EXPR_OSET,e_yy_EXPR_LINKED */
+
+abac_yy_expression_t *make_yy_expression(int type,void *pptr, void *optr, abac_yy_role_t *linked_role)
+{
+    abac_yy_expression_t *ptr=
+         (abac_yy_expression_t*)abac_xmalloc(sizeof(abac_yy_expression_t));
+    ptr->type = type;
+    if(type == e_yy_EXPR_OBJECT) {
+        ptr->object=(abac_yy_term_data_t *)pptr;
+        } else {
+            ptr->principal = (abac_yy_principal_t *)pptr;
+    }
+    if(type == e_yy_EXPR_OSET)
+        ptr->oset = (abac_yy_oset_t *) optr;
+        else
+            ptr->role = (abac_yy_role_t *) optr;
     ptr->linked_role=linked_role;
     ptr->next=NULL;
@@ -266,6 +515,13 @@
 }
 
-abac_yy_role_expression_t *add_yy_role_expression(abac_yy_role_expression_t *nexpr,
-                                               abac_yy_role_expression_t *exprs)
+abac_yy_term_data_t *get_yy_expression_object(abac_yy_expression_t *ptr)
+{
+   if(ptr->type == e_yy_EXPR_OBJECT)
+       return ptr->object;
+   return NULL;
+}
+
+abac_yy_expression_t *add_yy_expression(abac_yy_expression_t *nexpr,
+                                             abac_yy_expression_t *exprs)
 {
     int i=exprs->bcnt;
@@ -275,65 +531,33 @@
 }
 
-
-static void _free_yy_role_expression(abac_yy_role_expression_t *ptr)
-{
-    if(ptr->principal)
-        _free_yy_principal(ptr->principal);
-    if(ptr->role)
-        _free_yy_role(ptr->role);
+static void _free_yy_expression(abac_yy_expression_t *ptr)
+{
+    if(ptr->type == e_yy_EXPR_OBJECT) {
+       if(ptr->object)
+           _free_yy_term_data(ptr->object);
+       } else {
+           if(ptr->principal)
+               _free_yy_principal(ptr->principal);
+    }
+    if(ptr->type == e_yy_EXPR_OSET) {
+        if(ptr->oset) 
+            _free_yy_oset(ptr->oset);
+        } else {
+            if(ptr->role)
+                 _free_yy_role(ptr->role);
+    }
     if(ptr->linked_role)
         _free_yy_role(ptr->linked_role);
     if(ptr->next)
-        _free_yy_role_expression(ptr->next);
+        _free_yy_expression(ptr->next);
 
     free(ptr);
 }
 
-abac_yy_param_data_t *make_yy_param_data(char* name, char* typestr)
-{
-    int type=abac_verify_dterm_type(typestr);
-    abac_yy_param_data_t *ptr=
-              (abac_yy_param_data_t*)abac_xmalloc(sizeof(abac_yy_param_data_t));
+abac_yy_oset_t *make_yy_oset(char *name, abac_yy_term_t *terms)
+{
+    abac_yy_oset_t *ptr=(abac_yy_oset_t*)abac_xmalloc(sizeof(abac_yy_oset_t));
     ptr->name=abac_xstrdup(name);
-    ptr->type=type;
-    ptr->condition=NULL;
-    ptr->is_variable=0;
-    return ptr;
-}
-
-void set_yy_param_data_is_variable(abac_yy_param_data_t *ptr)
-{
-    ptr->is_variable=1;
-}
-
-static void _free_yy_param_data(abac_yy_param_data_t *ptr)
-{
-    free(ptr->name);
-    if(ptr->condition)
-        free(ptr->condition);
-    free(ptr);
-}
-
-abac_yy_param_principal_t *make_yy_param_principal(char* name)
-{
-    abac_yy_param_principal_t *ptr=
-            (abac_yy_param_principal_t*)abac_xmalloc(sizeof(abac_yy_param_principal_t));
-    ptr->name=abac_xstrdup(name);
-    ptr->condition=NULL;
-    return ptr;
-}
-
-static void _free_yy_param_principal(abac_yy_param_principal_t *ptr)
-{
-    free(ptr->name);
-    if(ptr->condition)
-        free(ptr->condition);
-    free(ptr);
-}
-
-abac_yy_dterm_t *make_yy_dterm_anonymous()
-{
-    abac_yy_dterm_t *ptr=(abac_yy_dterm_t*)abac_xmalloc(sizeof(abac_yy_dterm_t));
-    ptr->type = DTERM_ANONYMOUS;
+    ptr->terms=terms;
     ptr->next=NULL;
     ptr->bcnt=1;
@@ -341,92 +565,44 @@
 }
 
-abac_yy_dterm_t *make_yy_dterm_principal(abac_yy_param_principal_t *pptr)
-{
-    abac_yy_dterm_t *ptr=(abac_yy_dterm_t*)abac_xmalloc(sizeof(abac_yy_dterm_t));
-    ptr->type = DTERM_PRINCIPAL;
-    ptr->term.p_ptr=pptr;
-    ptr->next=NULL;
-    ptr->bcnt=1;
-    return ptr;
-}
-
-abac_yy_dterm_t *make_yy_dterm_named(abac_yy_principal_t *nptr)
-{
-    abac_yy_dterm_t *ptr=(abac_yy_dterm_t*)abac_xmalloc(sizeof(abac_yy_dterm_t));
-    ptr->type = DTERM_NAMED;
-    ptr->term.n_ptr=nptr;
-    ptr->next=NULL;
-    ptr->bcnt=1;
-    return ptr;
-}
-
-abac_yy_dterm_t *make_yy_dterm_data(abac_yy_param_data_t *dptr)
-{
-    abac_yy_dterm_t *ptr=(abac_yy_dterm_t*)abac_xmalloc(sizeof(abac_yy_dterm_t));
-    ptr->type = DTERM_DATA;
-    ptr->term.d_ptr=dptr;
-    ptr->next=NULL;
-    ptr->bcnt=1;
-    return ptr;
-}
-
-abac_yy_dterm_t *add_yy_dterm(abac_yy_dterm_t *nterm, abac_yy_dterm_t *dterms)
-{
-    int i=dterms->bcnt;
-    nterm->next=dterms;
-    nterm->bcnt=i+1;
-    return nterm;
-}
-
-static void _free_yy_dterm(abac_yy_dterm_t *ptr)
-{
-    switch (ptr->type) {
-        case DTERM_DATA:
-            _free_yy_param_data(ptr->term.d_ptr);
-            break;
-        case DTERM_NAMED:
-            _free_yy_principal(ptr->term.n_ptr);
-            break;
-        case DTERM_PRINCIPAL:
-            _free_yy_param_principal(ptr->term.p_ptr);
-            break;
-        case DTERM_ANONYMOUS:
-            break;
-    }
+static void _free_yy_oset(abac_yy_oset_t *ptr)
+{
+    free(ptr->name);
+    if(ptr->terms)
+        _free_yy_term(ptr->terms);
     if(ptr->next)
-        _free_yy_dterm(ptr->next);
+        _free_yy_oset(ptr->next);
     free(ptr);
 }
 
-/****************************************************************/
-static void _role_add_dterms(int linked, abac_role_t *role, abac_yy_dterm_t *dterms)
-{
-    abac_yy_dterm_t *curr = dterms;
+/**********************************************************************/
+static void _oset_add_terms(int linked, abac_oset_t *oset, 
+abac_yy_term_t *terms)
+{
+    abac_yy_term_t *curr = terms;
     int type;
     char *name=NULL;
     char *cond=NULL;
+    void *ptr=NULL;
     while (curr) {
         switch (curr->type) {
-           case DTERM_DATA:
+           case e_yy_DTERM_DATA:
            {
-               abac_yy_param_data_t *ptr=curr->term.d_ptr;
+               abac_yy_term_data_t *ptr=curr->term.d_ptr;
                type=ptr->type;
                name=abac_xstrdup(ptr->name);
                cond=abac_xstrdup(ptr->condition);
-               if(ptr->is_variable) {
-/* XXX do some tracking */
-               }
+               ptr=ptr->cptr;
                break;
            }
-           case DTERM_PRINCIPAL:
+           case e_yy_DTERM_PRINCIPAL:
            {
-              abac_yy_param_principal_t *ptr=curr->term.p_ptr;
-              type=abac_verify_dterm_type("principal");
-              name=abac_xstrdup(ptr->name);
-              cond=abac_xstrdup(ptr->condition);
-/* XXX variable one, do some tracking */
-              break;
+               abac_yy_term_principal_t *ptr=curr->term.p_ptr;
+               type=abac_verify_term_type("principal");
+               name=abac_xstrdup(ptr->name);
+               cond=abac_xstrdup(ptr->condition);
+               ptr=ptr->cptr;
+               break;
            }
-           case DTERM_NAMED:
+           case e_yy_DTERM_NAMED:
            {
               abac_yy_principal_t *ptr=curr->term.n_ptr;
